/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action delete_text_line(doc *d, int line)
{
  data {
    int line;
    char *text;
  }

  do {
    data->line = line;
    data->text = LINE_TEXT_DATA(d, data->line);

    size_predelete_line(d, line);

    LINE_TEXT_DATA(d, data->line) = NULL;

    if (!doc_delete_line(d, line)) {
      LINE_TEXT_DATA(d, data->line) = data->text;
      /* size_predelete_line modifies the global height, we need to reset */
      size_reset(d);
      return 0;
    }

    if (REGISTER_HISTORY < 0) {
      set_error(OOM);
      doc_insert_line(d, LINE_TEXT, line-1);
      LINE_TEXT_DATA(d, data->line) = data->text;
      data->text = NULL;
      /* size_predelete_line modifies the global height, we need to reset */
      size_reset(d);
      return 0;
    }

    size_delete_line(d, line);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    size_prenew_line(d, data->line);
    doc_insert_line(d, LINE_TEXT, data->line-1);
    LINE_TEXT_DATA(d, data->line) = data->text;
    data->text = NULL;
    d->cursor.line = data->line;
    d->cursor.chord = 0;
    size_new_line(d, data->line);
    d->state = STATE_MODIFIED;
  }

  redo {
    size_predelete_line(d, data->line);
    data->text = LINE_TEXT_DATA(d, data->line);
    LINE_TEXT_DATA(d, data->line) = NULL;
    doc_delete_line(d, data->line);
    d->cursor.line = data->line >= d->size ? d->size-1 : data->line;
    d->cursor.chord = 0;
    size_delete_line(d, data->line);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
    if (data->text) {
      free(data->text);
      data->text = NULL;
    }
  }
}
