/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_note_alteration(doc *d, int line, int chord, int note,
                           note_alteration t)
{
  data {
    int line;
    int chord;
    int note;
    note_alteration old_value;
    note_alteration new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->note = note;
    data->old_value = NOTE_ALTERATION(d, line, chord, note);
    data->new_value = t;

    if (!doc_set_note_alteration(d, line, chord, note, t)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_note_alteration(d, line, chord, note, data->old_value);
      return -1;
    }

    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    doc_set_note_alteration(d, data->line, data->chord, data->note,
                            data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    doc_set_note_alteration(d, data->line, data->chord, data->note,
                            data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
