/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_note_dot(doc *d, int line, int chord, int note, int nb_dots)
{
  data {
    int line;
    int chord;
    int note;
    int old_value;
    int new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->note = note;
    switch (NOTE_TYPE(d, line, chord, note)) {
      case NOTE:
        data->old_value = NOTE_NB_DOTS(d, line, chord, note);
        break;
      case SILENCE:
        data->old_value = SILENCE_NB_DOTS(d, line, chord, note);
        break;
    }
    data->new_value = nb_dots;

    if (!doc_set_note_dot(d, line, chord, note, nb_dots)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_note_dot(d, line, chord, note, data->old_value);
      return -1;
    }

    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    doc_set_note_dot(d, data->line, data->chord, data->note,
                     data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    doc_set_note_dot(d, data->line, data->chord, data->note,
                     data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
