/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_note_dots_delta(doc *d, int line, int chord, int note, int delta)
{
  data {
    int line;
    int chord;
    int note;
    int old_value;
    int new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->old_value = NOTE_DOTS_DELTA(d, line, chord, note);
    data->new_value = delta;
    data->note = note;

    if (!doc_set_note_dots_delta(d, line, chord, note, delta)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_note_dots_delta(d, line, chord, data->note, data->old_value);
      return -1;
    }

    d->state = STATE_MODIFIED;
    size_change_chord(d, line, chord);

    return 0;
  }

  undo {
    (void)doc_set_note_dots_delta(d, data->line, data->chord, data->note,
                                  data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    (void)doc_set_note_dots_delta(d, data->line, data->chord, data->note,
                                  data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
