/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_note_position(doc *d, int line, int chord, int note, int position)
{
  data {
    int line;
    int chord;
    int note;
    int old_value;
    int new_value;
  }

  do {
    int n;
    data->line = line;
    data->chord = chord;
    data->old_value = SILENCE_POSITION(d, line, chord, note);
    data->new_value = position;

    if (!(n = doc_set_note_position(d, line, chord, note, position)))
      return 0;
    data->note = n - 1;

    if (REGISTER_HISTORY < 0) {
      doc_set_note_position(d, line, chord, data->note, data->old_value);
      return -1;
    }

    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;

    return n;
  }

  undo {
    data->note = doc_set_note_position(d, data->line, data->chord,
                                       data->note,
                                       data->old_value) - 1;
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    data->note = doc_set_note_position(d, data->line, data->chord,
                                       data->note,
                                       data->new_value) - 1;
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
