/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

/* we barbarianly copy the string, it may eat up a lot of memory
 * if tiny modifications are done on long strings but hey, who
 * will use very long lines? this is not a text editor.
 */
action set_text(doc *d, int line, char *text)
{
  data {
    int line;
    char *text;
  }

  do {
    data->line = line;
    data->text = LINE_TEXT_DATA(d, data->line);
    char *t = strdup(text);

    if (!t) {
      set_error(OOM);
      return 0;
    }

    LINE_TEXT_DATA(d, data->line) = t;

    if (REGISTER_HISTORY < 0) {
      set_error(OOM);
      free(t);
      LINE_TEXT_DATA(d, data->line) = data->text;
      return 0;
    }

    size_set_text(d, data->line);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    char *t = data->text;
    data->text = LINE_TEXT_DATA(d, data->line);
    LINE_TEXT_DATA(d, data->line) = t;
    d->cursor.line = data->line;
    d->cursor.chord = 0;
    size_set_text(d, data->line);
    d->state = STATE_MODIFIED;
  }

  redo {
    char *t = data->text;
    data->text = LINE_TEXT_DATA(d, data->line);
    LINE_TEXT_DATA(d, data->line) = t;
    d->cursor.line = data->line;
    d->cursor.chord = 0;
    size_set_text(d, data->line);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
    if (data->text) {
      free(data->text);
      data->text = NULL;
    }
  }
}
