/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_tonalite_alteration(doc *d, int line, int chord,
                               note_alteration a)
{
  data {
    int line;
    int chord;
    note_alteration old_value;
    note_alteration new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->old_value = TONALITE_ALTERATION(d, line, chord);
    data->new_value = a;

    if (!doc_set_tonalite_alteration(d, line, chord, a)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_tonalite_alteration(d, line, chord, data->old_value);
      return -1;
    }

    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    doc_set_tonalite_alteration(d, data->line, data->chord,
                                data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    doc_set_tonalite_alteration(d, data->line, data->chord,
                                data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
