/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_tonalite_position(doc *d, int line, int chord,
                             int position)
{
  data {
    int line;
    int chord;
    int old_value;
    int new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->old_value = TONALITE_POSITION(d, line, chord);
    data->new_value = position;

    if (!doc_set_tonalite_position(d, line, chord, position)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_tonalite_position(d, line, chord, data->old_value);
      return -1;
    }

    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;

    return 1;
  }

  undo {
    doc_set_tonalite_position(d, data->line, data->chord,
                              data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    doc_set_tonalite_position(d, data->line, data->chord,
                              data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
