/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _DIM_H_
#define _DIM_H_

/* defines the maximum and minimum allowed notes
 * (0 = middle G, 7 = higher G, -7 = lower G)
 * This is the position on the staff; if you put a clef
 * these values won't change. The line 0 is the second
 * line starting from bottom whatever clef you have before.
 */
#define STAFF_NOTE_MIN		-22
#define STAFF_NOTE_MAX		26

#define CLEF_POS_MIN		-3
#define CLEF_POS_MAX		7

#define LINE_SPACING		8

#define MINILINE_WIDTH		15

#define LINE_LINE_SPACE		20

/* #define LINE_HEIGHT		(LINE_SPACING * 15 + 1 + 10) */
#define LINE_HEIGHT		(LINE_SPACING * 4 + 1)
#define UPPER_MARGIN		20
#define LOWER_MARGIN		20
#define LEFT_MARGIN		10
#define RIGHT_MARGIN		10
#define LEFT_LINE_BORDER	5
#define RIGHT_LINE_BORDER	5

#define TEXT_UPPER_MARGIN	10
#define TEXT_LOWER_MARGIN	10
#define TEXT_LEFT_BORDER	5
#define TEXT_RIGHT_BORDER	5

#define MESURE_MARKER_WIDTH	2
#define NOTHING_WIDTH		1

#define MIN_LINE_WIDTH		200

#define HEAD_HEAD_MIN_SPACE	20	/* min space center of 2 notes */

#define NOTE_HEAD_SPACE		4
#define DIESE_SPACE		3
#define BEMOL_SPACE		3
#define BECARRE_SPACE		3
#define DOT_SPACE		2	/* space between dots */
#define DOT_NOTE_SPACE		3	/* space between note and first dot */
#define DOT_SILENCE_SPACE	3	/* space between silence and 1st dot */
#define SILENCE_RONDE_SPACE	4
#define SILENCE_BLANCHE_SPACE	4
#define SILENCE_NOIRE_SPACE	4
#define SILENCE_CROCHE_SPACE	4
#define SILENCE_DCROCHE_SPACE	4
#define SILENCE_DDCROCHE_SPACE	4
#define SILENCE_DDDCROCHE_SPACE	4
#define SILENCE_DDDDCROCHE_SPACE	4
#define MESURE_MARKER_SPACE	5
#define CLEF_SPACE		5
#define NOTHING_SPACE		3

#define TONALITE_OR_CLEF_NOTE_SPACE	15

/* additional space for minimal chord's duration */
#define RONDE_SPACE		40
#define BLANCHE_SPACE		30
#define NOIRE_SPACE		20
#define CROCHE_SPACE		10
#define DCROCHE_SPACE		0
#define DDCROCHE_SPACE		0
#define DDDCROCHE_SPACE		0
#define DDDDCROCHE_SPACE	0

/* when drawing a bemol we use its height to get its center
 * but the real center has to be adjusted
 * this should be font specific
 */
#define BEMOL_ADJUST		4

#define CLEF_C_ADJUST		0
#define CLEF_F_ADJUST		(-5)
#define CLEF_G_ADJUST		7
#define CLEF_G_8va_ADJUST	3
#define CLEF_G_8vb_ADJUST	3

/* same remark for below stuff */
#define DCROCHE_ADJUST		8
#define DDCROCHE_ADJUST		(8*2)
#define DDDCROCHE_ADJUST	(8*3)
#define DDDDCROCHE_ADJUST	(8*4)

#define RONDE_SILENCE_ADJUST	2
#define BLANCHE_SILENCE_ADJUST	(-1)

/* number of pixels to scroll with the mouse wheel */
#define MOUSE_WHEEL_SCROLL	100

/* min/max for delta stuff */
#define MIN_NOTE_HEAD_DELTA	-100
#define MAX_NOTE_HEAD_DELTA	100
#define MIN_ALTERATION_DELTA	-100
#define MAX_ALTERATION_DELTA	100
#define MIN_DOTS_DELTA		-100
#define MAX_DOTS_DELTA		100

#endif /* _DIM_H_ */
