/* generate frequencies of notes. */
/* public domain stuff */
/* middle A = 440 Hz
 * To get 1/2 tone higher, you have to do: cur_freq * 2^(1/12)
 * because you have 12 1/2 tones per octave and the freq
 * of higher A is freq of middle A * 2
 * You deduce the following values by applying the above rule
 * again and again.
 */

#include <stdio.h>
#include <math.h>

/* G 2 A 2 B 1 C 2 D 2 E 1 F 2 */
int inc_tone[7] = { 2, 2, 1, 2, 2, 1, 2};

int base_to_tone[7] = { 0, 2, 4, 5, 7, 9, 10 };

void dump_note(int n)
{
  int base = n;
  int octave = 0;
  int tone;

  while (base < 0) { base += 7; octave-=12; }
  while (base > 6) { base -= 7; octave+=12; }

  tone = base_to_tone[base] + octave;

  /* 440 Hz for A, but A is at +2, so the -2 in the calculation */
  /* hum... seems 440 is too low. Let's do 880 */
  printf("  { %f, %f, %f} /* %d */,\n",
         2. * 440. * pow(2., (tone-3) / 12.) /* bemol */,
         2. * 440. * pow(2., (tone-2) / 12.) /* normal */,
         2. * 440. * pow(2., (tone-1) / 12.) /* diese */,
         n);
}

int main(void)
{
  int i;
  for (i = 0; i <= 6; i++) dump_note(i);
  return 0;
}
