/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _GTK_WRAPPER_H_
#define _GTK_WRAPPER_H_

#include "images.h"

/* some colors */
#define COLOR_GREEN	0
#define COLOR_BLUE	1
#define COLOR_BLACK	2
#define COLOR_WHITE	3
#define NB_COLORS	4

void gtk_wrapper_window_set_modal(void *, int);
void gtk_wrapper_set_sensitive(void *, int);
void gtk_wrapper_widget_show_all(void *);
void gtk_wrapper_main(void);
void gtk_wrapper_init(int *, char ***);
void gtk_wrapper_main_quit(void);
void gtk_wrapper_widget_destroy(void *);
void gtk_wrapper_widget_queue_draw(void *);
void gtk_wrapper_widget_queue_draw_area(void *, int, int, int, int, int);
void gtk_wrapper_label_set_text(void *, const char *);
void gtk_wrapper_entry_set_text(void *, const char *);

void gtk_wrapper_draw_line(void *, int, int, int, int, int);
void gtk_wrapper_draw_points(void *, void *, int, int, int, int);
void gtk_wrapper_draw_image(void *, enum image_type, int, int, int);

void *gtk_wrapper_alloc_points(int);
void gtk_wrapper_add_point(void *, int, int, int);

void gtk_wrapper_source_remove(unsigned int);
unsigned int gtk_wrapper_timeout_add(unsigned int, void *, void *);

void gtk_wrapper_drawing_area_set_dimension(void *, int, int, int);
#if 0
void gtk_wrapper_drawing_area_set_height(void *, int, int);
void gtk_wrapper_drawing_area_set_width(void *, int, int);
#endif
void gtk_wrapper_drawing_area_view(void *, int, int, int, int, int);

unsigned int gtk_wrapper_add_audio_callback(int, void *, void *);
void gtk_wrapper_remove_callback(unsigned int);

void gtk_set_color(int);

/* the gc should be created at startup but I need a win argument */
/* so this function should not be visible, but hey... */
void gtk_wrapper_create_gc(void *);

void gtk_wrapper_get_min_max(void *, int *, int *, int);
int gtk_wrapper_get_width(void *d, int);
int gtk_wrapper_get_height(void *d, int);
int gtk_wrapper_get_visible_height(void *d, int);

void *gtk_wrapper_get_tutorial_iter(void);
void gtk_wrapper_text_buffer_get_iter_at_offset(void *, void *, int);
void gtk_wrapper_text_buffer_place_cursor(void *, void *);
void gtk_wrapper_insert_one(void*, void*, char*, int, char*);
void gtk_wrapper_insert_two(void*, void*, char*, int, char*, char*);
void gtk_wrapper_clear_text(void *);

void gtk_wrapper_text_view_begin(void *);

void gtk_wrapper_string_size(void *, int, void *, int *, int *);
void gtk_wrapper_draw_string(void *, void *, char *, int, int, int);

int gtk_wrapper_get_scroll_value_x(void *d);
int gtk_wrapper_get_scroll_value_y(void *d);
void gtk_wrapper_set_scroll_value_x(void *d, int);
void gtk_wrapper_set_scroll_value_y(void *d, int);

void *gtk_wrapper_create_bitmap(char *, int, int);

#endif /* _GTK_WRAPPER_H_ */
