/* generated by gtkcooker (http://sed.free.fr/gtkcooker) */

#include <gtk/gtk.h>
#include "main_gui.h"

#include "thread.h"
#include "states.h"
#include "draw.h"
#include "doc.h"
#include "dim.h"
#include "quick_help_gui.h"
#include "known_bugs_gui.h"
#include "todo_gui.h"
#include "keyboard_gui.h"
#include "grey.h"
#include <gdk/gdkkeysyms.h>
#include "icons/1.h"
#include "icons/2.h"
#include "icons/4.h"
#include "icons/8.h"
#include "icons/16.h"
#include "icons/32.h"
#include "icons/64.h"
#include "icons/128.h"



void setup_tempo(doc *d)
{
  const char *t = gtk_entry_get_text(GTK_ENTRY(d->tempo_text));
  char s[64];
  int tempo;
  if (sscanf(t, "%d", &tempo) != 1 || tempo <= 0 || tempo > 1000) {
    d->tempo = 80;
    gtk_entry_set_text(GTK_ENTRY(d->tempo_text), "80");
    return;
  }
  d->tempo = tempo;
  sprintf(s, "%d", tempo);
  gtk_entry_set_text(GTK_ENTRY(d->tempo_text), s);
}

void display_tempo(doc *d)
{
  char s[64];
  sprintf(s, "%d", d->tempo);
  gtk_entry_set_text(GTK_ENTRY(d->tempo_text), s);
}

void tempo_grab(doc *d)
{
  gtk_widget_grab_focus(d->tempo_text);
}

static void set_default_duration(gui *g, note_duration len)
{
  switch (len) {
    case RONDE:
      g->duration = RONDE;
      break;
    case BLANCHE:
      g->duration = BLANCHE;
      break;
    case NOIRE:
      g->duration = NOIRE;
      break;
    case CROCHE:
      g->duration = CROCHE;
      break;
    case DCROCHE:
      g->duration = DCROCHE;
      break;
    case DDCROCHE:
      g->duration = DDCROCHE;
      break;
    case DDDCROCHE:
      g->duration = DDDCROCHE;
      break;
    case DDDDCROCHE:
      g->duration = DDDDCROCHE;
      break;
  }

  gtk_widget_grab_focus(g->d);
}

note_duration get_gui_duration(gui *g)
{
  return g->duration;
}


static gboolean _1(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
{DO_QUIT(this->t);}
  return TRUE;
}

static void _6(GtkMenuItem *_widget, gui *this)
{
  {DO_NEW(this->t);}
}

static void _8(GtkMenuItem *_widget, gui *this)
{
  {DO_LOAD(this->t);}
}

static void _10(GtkMenuItem *_widget, gui *this)
{
  {DO_SAVE(this->t);}
}

static void _12(GtkMenuItem *_widget, gui *this)
{
  {DO_SAVE_AS(this->t);}
}

static void _14(GtkMenuItem *_widget, gui *this)
{
  {DO_OPTIONS(this->t);}
}

static void _16(GtkMenuItem *_widget, gui *this)
{
  {DO_QUIT(this->t);}
}

static void _18(GtkMenuItem *_widget, gui *this)
{
  {DO_UNDO(this->t);}
}

static void _20(GtkMenuItem *_widget, gui *this)
{
  {DO_REDO(this->t);}
}

static void _22(GtkMenuItem *_widget, gui *this)
{
  {DO_SELECTION_COPY(this->t);}
}

static void _24(GtkMenuItem *_widget, gui *this)
{
  {DO_SELECTION_PASTE(this->t);}
}

static void _28(GtkMenuItem *_widget, gui *this)
{
  {show_keyboard(this->t, this);}
}

static void _30(GtkMenuItem *_widget, gui *this)
{
  {DO_ABOUT(this->t);}
}

static void _32(GtkMenuItem *_widget, gui *this)
{
  {DO_AUTHORS(this->t);}
}

static void _34(GtkMenuItem *_widget, gui *this)
{
  {show_quick_help();}
}

static void _36(GtkMenuItem *_widget, gui *this)
{
  {DO_TUTORIAL(this->t);}
}

static void _38(GtkMenuItem *_widget, gui *this)
{
  {show_known_bugs();}
}

static void _40(GtkMenuItem *_widget, gui *this)
{
  {show_todo();}
}

static void _42(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_1), TRUE);}
}

static void _44(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_2), TRUE);}
}

static void _46(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_4), TRUE);}
}

static void _48(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_8), TRUE);}
}

static void _50(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_16), TRUE);}
}

static void _52(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_32), TRUE);}
}

static void _54(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_64), TRUE);}
}

static void _56(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->duration_128), TRUE);}
}

static void _58(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->zoom1), TRUE);}
}

static void _60(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->zoom2), TRUE);}
}

static void _62(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->zoom3), TRUE);}
}

static void _64(GtkMenuItem *_widget, gui *this)
{
  {gtk_toggle_button_set_active(
                           GTK_TOGGLE_BUTTON(this->zoom4), TRUE);}
}

static void _66(GtkEntry *_widget, gui *this)
{
  {gtk_widget_grab_focus(this->d);}
}

static void _67(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, RONDE);}
}

static void _68(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, BLANCHE);}
}

static void _69(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, NOIRE);}
}

static void _70(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, CROCHE);}
}

static void _71(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, DCROCHE);}
}

static void _72(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, DDCROCHE);}
}

static void _73(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, DDDCROCHE);}
}

static void _74(GtkButton *_widget, gui *this)
{
  {set_default_duration(this, DDDDCROCHE);}
}

static void _76(GtkButton *_widget, gui *this)
{
  { set_zoom(this->doc, 1); gtk_widget_grab_focus(this->d); }
}

static void _78(GtkButton *_widget, gui *this)
{
  { set_zoom(this->doc, 2); gtk_widget_grab_focus(this->d); }
}

static void _80(GtkButton *_widget, gui *this)
{
  { set_zoom(this->doc, 3); gtk_widget_grab_focus(this->d); }
}

static void _82(GtkButton *_widget, gui *this)
{
  { set_zoom(this->doc, 4); gtk_widget_grab_focus(this->d); }
}

static gboolean _83(GtkWidget *_widget, GdkEventExpose *_event, gui *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  {draw_area(this->doc,
                       x / this->doc->zoom,
                       y / this->doc->zoom,
                       width / this->doc->zoom,
                       height /this->doc->zoom);}
  return TRUE;
}

static gboolean _84(GtkWidget *_widget, GdkEventKey *_event, gui *this)
{
  int key = _event->keyval;
  int modifier = _event->state;
  
    if (_event->type != GDK_KEY_PRESS) return TRUE;
#define HAS_CONTROL(x) ((x) & GDK_CONTROL_MASK)
#define HAS_SHIFT(x) ((x) & GDK_SHIFT_MASK)
  
  {
    if (HAS_CONTROL(modifier) && key == 't') tempo_grab(this->doc);
    else {
      _DO_KEY_PRESS(this->t, key, HAS_CONTROL(modifier), HAS_SHIFT(modifier));
    }
  }
  return TRUE;
#undef HAS_CONTROL
#undef HAS_SHIFT
}

static gboolean _85(GtkWidget *_widget, GdkEventFocus *_event, gui *this)
{
  int in = _event->in;
  
  {
    if (in) enable_cursor(&this->doc->cursor);
    else disable_cursor(&this->doc->cursor);
  }
  return TRUE;
}

static gboolean _86(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    switch (type) {
      case GDK_MOTION_NOTIFY:
        if (this->is_mouse_clicked) {
          this->has_mouse_moved = 1;
          gtk_wrapper_set_scroll_value_x(this->d,
              this->scroll_value_start_x -
                _event->motion.x_root +
                this->mouse_start_x);
          gtk_wrapper_set_scroll_value_y(this->d,
              this->scroll_value_start_y -
              _event->motion.y_root +
              this->mouse_start_y);
        }
        break;
      case GDK_BUTTON_PRESS:
        gtk_widget_grab_focus(this->d);
        /* handle mouse wheel */
        if (button == 4) {
          /* scroll up */
          gtk_wrapper_set_scroll_value_y(this->d,
              gtk_wrapper_get_scroll_value_y(this->d) - MOUSE_WHEEL_SCROLL);
        } else if (button == 5) {
          /* scroll down */
          gtk_wrapper_set_scroll_value_y(this->d,
              gtk_wrapper_get_scroll_value_y(this->d) + MOUSE_WHEEL_SCROLL);
        }
        else if (button == 1) {
          this->is_mouse_clicked=1;
          this->has_mouse_moved = 0;
          this->mouse_start_x = _event->button.x_root;
          this->mouse_start_y = _event->button.y_root;
          this->scroll_value_start_x =
              gtk_wrapper_get_scroll_value_x(this->d);
          this->scroll_value_start_y =
              gtk_wrapper_get_scroll_value_y(this->d);
        }
        break;
      case GDK_2BUTTON_PRESS: break;
      case GDK_3BUTTON_PRESS: break;
      case GDK_BUTTON_RELEASE:
        if (button == 1) {
          if (this->is_mouse_clicked && !this->has_mouse_moved)
            _DO_MOUSE_CLICK(this->t, x, y);
          this->is_mouse_clicked=0;
        }
        break;
      default: break;
    }
  }
  return TRUE;
}

/* returns -1 on error, 0 if everything is fine */
int init_gui(gui *this, thread t, doc *d)
{
  GtkWidget *_0;
  GtkWidget *m;
  GtkWidget *m_0;
  GtkWidget *_2;
  GtkWidget *m_1;
  GtkWidget *_3;
  GtkWidget *m_2;
  GtkWidget *_4;
  GtkWidget *m_3;
  GtkWidget *_5;
  GtkWidget *m_file;
  GtkWidget *m_file_0;
  GtkWidget *_7;
  GtkWidget *m_file_1;
  GtkWidget *_9;
  GtkWidget *m_file_2;
  GtkWidget *_11;
  GtkWidget *m_file_3;
  GtkWidget *_13;
  GtkWidget *m_file_5;
  GtkWidget *_15;
  GtkWidget *m_file_7;
  GtkWidget *_17;
  GtkWidget *m_edit;
  GtkWidget *m_edit_0;
  GtkWidget *_19;
  GtkWidget *m_edit_1;
  GtkWidget *_21;
  GtkWidget *m_edit_3;
  GtkWidget *_23;
  GtkWidget *m_edit_4;
  GtkWidget *_25;
  GtkWidget *m_edit_6;
  GtkWidget *_26;
  GtkWidget *m_edit_7;
  GtkWidget *_27;
  GtkWidget *m_tool;
  GtkWidget *m_tool_0;
  GtkWidget *_29;
  GtkWidget *m_help;
  GtkWidget *m_help_0;
  GtkWidget *_31;
  GtkWidget *m_help_2;
  GtkWidget *_33;
  GtkWidget *m_help_4;
  GtkWidget *_35;
  GtkWidget *m_help_5;
  GtkWidget *_37;
  GtkWidget *m_help_7;
  GtkWidget *_39;
  GtkWidget *m_help_8;
  GtkWidget *_41;
  GtkWidget *m_duration;
  GtkWidget *m_duration_0;
  GtkWidget *_43;
  GtkWidget *m_duration_1;
  GtkWidget *_45;
  GtkWidget *m_duration_2;
  GtkWidget *_47;
  GtkWidget *m_duration_3;
  GtkWidget *_49;
  GtkWidget *m_duration_4;
  GtkWidget *_51;
  GtkWidget *m_duration_5;
  GtkWidget *_53;
  GtkWidget *m_duration_6;
  GtkWidget *_55;
  GtkWidget *m_duration_7;
  GtkWidget *_57;
  GtkWidget *m_zoom;
  GtkWidget *m_zoom_0;
  GtkWidget *_59;
  GtkWidget *m_zoom_1;
  GtkWidget *_61;
  GtkWidget *m_zoom_2;
  GtkWidget *_63;
  GtkWidget *m_zoom_3;
  GtkWidget *_65;
  GtkWidget *tempo_label;
  GtkWidget *tempo_box;
  GtkWidget *duration_box;
  GtkWidget *ib_1;
  GtkWidget *ib_2;
  GtkWidget *ib_4;
  GtkWidget *ib_8;
  GtkWidget *ib_16;
  GtkWidget *ib_32;
  GtkWidget *ib_64;
  GtkWidget *ib_128;
  GtkWidget *zoom_box;
  GtkWidget *_75;
  GtkWidget *_77;
  GtkWidget *_79;
  GtkWidget *_81;
  GtkWidget *_93;
  GtkWidget *_87;
  GtkWidget *_88;
  GtkWidget *_89;
  GtkWidget *_90;
  GtkWidget *_91;
  GtkWidget *_92;
  GtkWidget *_94;

  {
    this->t = t;
    this->doc = d;
    this->is_mouse_clicked = 0;
    this->duration = NOIRE;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request((GtkWidget *)this->win, 800, 600);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  m = gtk_menu_bar_new();
  m_0 = gtk_menu_item_new();
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "_File");
  gtk_misc_set_alignment(GTK_MISC(_2), 0.000000, 0.500000);
  m_1 = gtk_menu_item_new();
  _3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_3), "_Edit");
  gtk_misc_set_alignment(GTK_MISC(_3), 0.000000, 0.500000);
  m_2 = gtk_menu_item_new();
  _4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_4), "_Tools");
  gtk_misc_set_alignment(GTK_MISC(_4), 0.000000, 0.500000);
  m_3 = gtk_menu_item_new();
  _5 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_5), "_Help");
  gtk_misc_set_alignment(GTK_MISC(_5), 0.000000, 0.500000);
  m_file = gtk_menu_new();
  m_file_0 = gtk_menu_item_new();
  _7 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_7), "_New");
  gtk_misc_set_alignment(GTK_MISC(_7), 0.000000, 0.500000);
  m_file_1 = gtk_menu_item_new();
  _9 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_9), "_Open");
  gtk_misc_set_alignment(GTK_MISC(_9), 0.000000, 0.500000);
  m_file_2 = gtk_menu_item_new();
  _11 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_11), "_Save (ctrl+s)");
  gtk_misc_set_alignment(GTK_MISC(_11), 0.000000, 0.500000);
  m_file_3 = gtk_menu_item_new();
  _13 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_13), "Save _as");
  gtk_misc_set_alignment(GTK_MISC(_13), 0.000000, 0.500000);
  m_file_5 = gtk_menu_item_new();
  _15 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_15), "O_ptions");
  gtk_misc_set_alignment(GTK_MISC(_15), 0.000000, 0.500000);
  m_file_7 = gtk_menu_item_new();
  _17 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_17), "_Quit");
  gtk_misc_set_alignment(GTK_MISC(_17), 0.000000, 0.500000);
  m_edit = gtk_menu_new();
  m_edit_0 = gtk_menu_item_new();
  _19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_19), "_Undo (ctrl+z)");
  gtk_misc_set_alignment(GTK_MISC(_19), 0.000000, 0.500000);
  m_edit_1 = gtk_menu_item_new();
  _21 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_21), "_Redo (ctrl+y)");
  gtk_misc_set_alignment(GTK_MISC(_21), 0.000000, 0.500000);
  m_edit_3 = gtk_menu_item_new();
  _23 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_23), "_Copy (ctrl+c)");
  gtk_misc_set_alignment(GTK_MISC(_23), 0.000000, 0.500000);
  m_edit_4 = gtk_menu_item_new();
  _25 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_25), "_Paste (ctrl+v)");
  gtk_misc_set_alignment(GTK_MISC(_25), 0.000000, 0.500000);
  m_edit_6 = gtk_menu_item_new();
  _26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_26), "_Default duration");
  gtk_misc_set_alignment(GTK_MISC(_26), 0.000000, 0.500000);
  m_edit_7 = gtk_menu_item_new();
  _27 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_27), "_Zoom");
  gtk_misc_set_alignment(GTK_MISC(_27), 0.000000, 0.500000);
  m_tool = gtk_menu_new();
  m_tool_0 = gtk_menu_item_new();
  _29 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_29), "_Virtual keyboard");
  gtk_misc_set_alignment(GTK_MISC(_29), 0.000000, 0.500000);
  m_help = gtk_menu_new();
  m_help_0 = gtk_menu_item_new();
  _31 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_31), "_About");
  gtk_misc_set_alignment(GTK_MISC(_31), 0.000000, 0.500000);
  m_help_2 = gtk_menu_item_new();
  _33 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_33), "_Contact the authors");
  gtk_misc_set_alignment(GTK_MISC(_33), 0.000000, 0.500000);
  m_help_4 = gtk_menu_item_new();
  _35 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_35), "_Quick help");
  gtk_misc_set_alignment(GTK_MISC(_35), 0.000000, 0.500000);
  m_help_5 = gtk_menu_item_new();
  _37 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_37), "_Tutorial");
  gtk_misc_set_alignment(GTK_MISC(_37), 0.000000, 0.500000);
  m_help_7 = gtk_menu_item_new();
  _39 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_39), "_Known bugs");
  gtk_misc_set_alignment(GTK_MISC(_39), 0.000000, 0.500000);
  m_help_8 = gtk_menu_item_new();
  _41 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_41), "T_odo");
  gtk_misc_set_alignment(GTK_MISC(_41), 0.000000, 0.500000);
  m_duration = gtk_menu_new();
  m_duration_0 = gtk_menu_item_new();
  _43 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_43), "_Semibreve");
  gtk_misc_set_alignment(GTK_MISC(_43), 0.000000, 0.500000);
  m_duration_1 = gtk_menu_item_new();
  _45 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_45), "_Minim");
  gtk_misc_set_alignment(GTK_MISC(_45), 0.000000, 0.500000);
  m_duration_2 = gtk_menu_item_new();
  _47 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_47), "_Crotchet");
  gtk_misc_set_alignment(GTK_MISC(_47), 0.000000, 0.500000);
  m_duration_3 = gtk_menu_item_new();
  _49 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_49), "_Quaver");
  gtk_misc_set_alignment(GTK_MISC(_49), 0.000000, 0.500000);
  m_duration_4 = gtk_menu_item_new();
  _51 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_51), "S_emiquaver");
  gtk_misc_set_alignment(GTK_MISC(_51), 0.000000, 0.500000);
  m_duration_5 = gtk_menu_item_new();
  _53 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_53), "_Demisemiquaver");
  gtk_misc_set_alignment(GTK_MISC(_53), 0.000000, 0.500000);
  m_duration_6 = gtk_menu_item_new();
  _55 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_55), "_Hemidemisemiquaver");
  gtk_misc_set_alignment(GTK_MISC(_55), 0.000000, 0.500000);
  m_duration_7 = gtk_menu_item_new();
  _57 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_57), "Q_uasihemidemisemiquaver");
  gtk_misc_set_alignment(GTK_MISC(_57), 0.000000, 0.500000);
  m_zoom = gtk_menu_new();
  m_zoom_0 = gtk_menu_item_new();
  _59 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_59), "x_1");
  gtk_misc_set_alignment(GTK_MISC(_59), 0.000000, 0.500000);
  m_zoom_1 = gtk_menu_item_new();
  _61 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_61), "x_2");
  gtk_misc_set_alignment(GTK_MISC(_61), 0.000000, 0.500000);
  m_zoom_2 = gtk_menu_item_new();
  _63 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_63), "x_3");
  gtk_misc_set_alignment(GTK_MISC(_63), 0.000000, 0.500000);
  m_zoom_3 = gtk_menu_item_new();
  _65 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_65), "x_4");
  gtk_misc_set_alignment(GTK_MISC(_65), 0.000000, 0.500000);
  tempo_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(tempo_label), "Tempo");
  this->tempo_entry = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->tempo_entry),
    "80");
  gtk_widget_set_size_request((GtkWidget *)this->tempo_entry, 30, -1);
  tempo_box = gtk_vbox_new(FALSE, 0);
  duration_box = gtk_vbox_new(FALSE, 0);
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_1, FALSE, NULL);
    ib_1 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_2, FALSE, NULL);
    ib_2 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_4, FALSE, NULL);
    ib_4 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_8, FALSE, NULL);
    ib_8 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_16, FALSE, NULL);
    ib_16 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_32, FALSE, NULL);
    ib_32 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_64, FALSE, NULL);
    ib_64 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  {
    GdkPixbuf *_pix = gdk_pixbuf_new_from_inline(-1, icon_128, FALSE, NULL);
    ib_128 = gtk_image_new_from_pixbuf(_pix);
    g_object_unref(_pix);
  }
  this->duration_1 = gtk_radio_button_new(0);
  this->duration_2 = gtk_radio_button_new(0);
  this->duration_4 = gtk_radio_button_new(0);
  this->duration_8 = gtk_radio_button_new(0);
  this->duration_16 = gtk_radio_button_new(0);
  this->duration_32 = gtk_radio_button_new(0);
  this->duration_64 = gtk_radio_button_new(0);
  this->duration_128 = gtk_radio_button_new(0);
  zoom_box = gtk_vbox_new(FALSE, 0);
  this->zoom1 = gtk_radio_button_new(0);
  _75 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_75), "x1");
  this->zoom2 = gtk_radio_button_new(0);
  _77 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_77), "x2");
  this->zoom3 = gtk_radio_button_new(0);
  _79 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_79), "x3");
  this->zoom4 = gtk_radio_button_new(0);
  _81 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_81), "x4");
  _93 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_93),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_93),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_93),
      GTK_CORNER_TOP_LEFT);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_93, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_93, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_93, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_93, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_93, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->desc = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->desc), "");
  _87 = gtk_hbox_new(FALSE, 20);
  _88 = gtk_hbox_new(FALSE, 0);
  _89 = gtk_hbox_new(FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(_89), 5);
  _90 = gtk_hbox_new(FALSE, 5);
  gtk_container_set_border_width(GTK_CONTAINER(_90), 5);
  _91 = gtk_hbox_new(TRUE, 0);
  _92 = gtk_hbox_new(FALSE, 0);
  _94 = gtk_viewport_new(0, 0);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(_94),
      GTK_SHADOW_NONE);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_94, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_94, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_94, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_94, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)_94, GTK_STATE_INSENSITIVE, &_color);
    }
  }
  this->d = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->d, 1, 1);
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->d, GTK_STATE_NORMAL, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->d, GTK_STATE_ACTIVE, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->d, GTK_STATE_PRELIGHT, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->d, GTK_STATE_SELECTED, &_color);
    }
  }
  {
    PangoColor _pango_color;
    GdkColor _color;
    if (pango_color_parse(&_pango_color, "white")) {
      _color.red = _pango_color.red;
      _color.green = _pango_color.green;
     _color.blue = _pango_color.blue;
      gtk_widget_modify_bg((GtkWidget *)this->d, GTK_STATE_INSENSITIVE, &_color);
    }
  }

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_87, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_88, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_89, FALSE, FALSE, 0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m), (GtkWidget *)m_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m), (GtkWidget *)m_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(m), (GtkWidget *)m_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(m), (GtkWidget *)m_3);
  gtk_container_add(GTK_CONTAINER(m_0), (GtkWidget *)_2);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_0), (GtkWidget *)m_file);
  gtk_container_add(GTK_CONTAINER(m_1), (GtkWidget *)_3);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_1), (GtkWidget *)m_edit);
  gtk_container_add(GTK_CONTAINER(m_2), (GtkWidget *)_4);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_2), (GtkWidget *)m_tool);
  gtk_container_add(GTK_CONTAINER(m_3), (GtkWidget *)_5);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_3), (GtkWidget *)m_help);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_5);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_file), (GtkWidget *)m_file_7);
  gtk_container_add(GTK_CONTAINER(m_file_0), (GtkWidget *)_7);
  gtk_container_add(GTK_CONTAINER(m_file_1), (GtkWidget *)_9);
  gtk_container_add(GTK_CONTAINER(m_file_2), (GtkWidget *)_11);
  gtk_container_add(GTK_CONTAINER(m_file_3), (GtkWidget *)_13);
  gtk_container_add(GTK_CONTAINER(m_file_5), (GtkWidget *)_15);
  gtk_container_add(GTK_CONTAINER(m_file_7), (GtkWidget *)_17);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_6);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_edit), (GtkWidget *)m_edit_7);
  gtk_container_add(GTK_CONTAINER(m_edit_0), (GtkWidget *)_19);
  gtk_container_add(GTK_CONTAINER(m_edit_1), (GtkWidget *)_21);
  gtk_container_add(GTK_CONTAINER(m_edit_3), (GtkWidget *)_23);
  gtk_container_add(GTK_CONTAINER(m_edit_4), (GtkWidget *)_25);
  gtk_container_add(GTK_CONTAINER(m_edit_6), (GtkWidget *)_26);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_edit_6), (GtkWidget *)m_duration);
  gtk_container_add(GTK_CONTAINER(m_edit_7), (GtkWidget *)_27);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_edit_7), (GtkWidget *)m_zoom);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_tool), (GtkWidget *)m_tool_0);
  gtk_container_add(GTK_CONTAINER(m_tool_0), (GtkWidget *)_29);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_5);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), 
      gtk_separator_menu_item_new());
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_7);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_help), (GtkWidget *)m_help_8);
  gtk_container_add(GTK_CONTAINER(m_help_0), (GtkWidget *)_31);
  gtk_container_add(GTK_CONTAINER(m_help_2), (GtkWidget *)_33);
  gtk_container_add(GTK_CONTAINER(m_help_4), (GtkWidget *)_35);
  gtk_container_add(GTK_CONTAINER(m_help_5), (GtkWidget *)_37);
  gtk_container_add(GTK_CONTAINER(m_help_7), (GtkWidget *)_39);
  gtk_container_add(GTK_CONTAINER(m_help_8), (GtkWidget *)_41);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_3);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_4);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_5);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_6);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_duration), (GtkWidget *)m_duration_7);
  gtk_container_add(GTK_CONTAINER(m_duration_0), (GtkWidget *)_43);
  gtk_container_add(GTK_CONTAINER(m_duration_1), (GtkWidget *)_45);
  gtk_container_add(GTK_CONTAINER(m_duration_2), (GtkWidget *)_47);
  gtk_container_add(GTK_CONTAINER(m_duration_3), (GtkWidget *)_49);
  gtk_container_add(GTK_CONTAINER(m_duration_4), (GtkWidget *)_51);
  gtk_container_add(GTK_CONTAINER(m_duration_5), (GtkWidget *)_53);
  gtk_container_add(GTK_CONTAINER(m_duration_6), (GtkWidget *)_55);
  gtk_container_add(GTK_CONTAINER(m_duration_7), (GtkWidget *)_57);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_zoom), (GtkWidget *)m_zoom_0);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_zoom), (GtkWidget *)m_zoom_1);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_zoom), (GtkWidget *)m_zoom_2);
  gtk_menu_shell_append(GTK_MENU_SHELL(m_zoom), (GtkWidget *)m_zoom_3);
  gtk_container_add(GTK_CONTAINER(m_zoom_0), (GtkWidget *)_59);
  gtk_container_add(GTK_CONTAINER(m_zoom_1), (GtkWidget *)_61);
  gtk_container_add(GTK_CONTAINER(m_zoom_2), (GtkWidget *)_63);
  gtk_container_add(GTK_CONTAINER(m_zoom_3), (GtkWidget *)_65);
  gtk_box_pack_start(GTK_BOX(tempo_box), (GtkWidget *)_90, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(duration_box), (GtkWidget *)_91, TRUE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->duration_1), (GtkWidget *)ib_1);
  gtk_container_add(GTK_CONTAINER(this->duration_2), (GtkWidget *)ib_2);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_2),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_4), (GtkWidget *)ib_4);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_4),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_8), (GtkWidget *)ib_8);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_8),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_16), (GtkWidget *)ib_16);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_16),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_32), (GtkWidget *)ib_32);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_32),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_64), (GtkWidget *)ib_64);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_64),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_container_add(GTK_CONTAINER(this->duration_128), (GtkWidget *)ib_128);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->duration_128),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->duration_1)));
  gtk_box_pack_start(GTK_BOX(zoom_box), (GtkWidget *)_92, TRUE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->zoom1), (GtkWidget *)_75);
  gtk_container_add(GTK_CONTAINER(this->zoom2), (GtkWidget *)_77);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->zoom2),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->zoom1)));
  gtk_container_add(GTK_CONTAINER(this->zoom3), (GtkWidget *)_79);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->zoom3),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->zoom1)));
  gtk_container_add(GTK_CONTAINER(this->zoom4), (GtkWidget *)_81);
  gtk_radio_button_set_group(GTK_RADIO_BUTTON(this->zoom4),
      gtk_radio_button_get_group(GTK_RADIO_BUTTON(this->zoom1)));
  gtk_container_add(GTK_CONTAINER(_93), (GtkWidget *)_94);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)m, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)tempo_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)duration_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_87), (GtkWidget *)zoom_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_88), (GtkWidget *)_93, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_89), (GtkWidget *)this->desc, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_90), (GtkWidget *)tempo_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_90), (GtkWidget *)this->tempo_entry, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_1, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_2, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_4, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_8, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_16, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_32, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_64, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_91), (GtkWidget *)this->duration_128, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_92), (GtkWidget *)this->zoom1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_92), (GtkWidget *)this->zoom2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_92), (GtkWidget *)this->zoom3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_92), (GtkWidget *)this->zoom4, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_94), (GtkWidget *)this->d);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->duration_4), TRUE);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->zoom1), TRUE);


  this->win_delete = g_signal_connect(this->win, "delete-event", G_CALLBACK(_1), this);

  this->m_file_0_activate = g_signal_connect(m_file_0, "activate", G_CALLBACK(_6), this);

  this->m_file_1_activate = g_signal_connect(m_file_1, "activate", G_CALLBACK(_8), this);

  this->m_file_2_activate = g_signal_connect(m_file_2, "activate", G_CALLBACK(_10), this);

  this->m_file_3_activate = g_signal_connect(m_file_3, "activate", G_CALLBACK(_12), this);

  this->m_file_5_activate = g_signal_connect(m_file_5, "activate", G_CALLBACK(_14), this);

  this->m_file_7_activate = g_signal_connect(m_file_7, "activate", G_CALLBACK(_16), this);

  this->m_edit_0_activate = g_signal_connect(m_edit_0, "activate", G_CALLBACK(_18), this);

  this->m_edit_1_activate = g_signal_connect(m_edit_1, "activate", G_CALLBACK(_20), this);

  this->m_edit_3_activate = g_signal_connect(m_edit_3, "activate", G_CALLBACK(_22), this);

  this->m_edit_4_activate = g_signal_connect(m_edit_4, "activate", G_CALLBACK(_24), this);

  this->m_tool_0_activate = g_signal_connect(m_tool_0, "activate", G_CALLBACK(_28), this);

  this->m_help_0_activate = g_signal_connect(m_help_0, "activate", G_CALLBACK(_30), this);

  this->m_help_2_activate = g_signal_connect(m_help_2, "activate", G_CALLBACK(_32), this);

  this->m_help_4_activate = g_signal_connect(m_help_4, "activate", G_CALLBACK(_34), this);

  this->m_help_5_activate = g_signal_connect(m_help_5, "activate", G_CALLBACK(_36), this);

  this->m_help_7_activate = g_signal_connect(m_help_7, "activate", G_CALLBACK(_38), this);

  this->m_help_8_activate = g_signal_connect(m_help_8, "activate", G_CALLBACK(_40), this);

  this->m_duration_0_activate = g_signal_connect(m_duration_0, "activate", G_CALLBACK(_42), this);

  this->m_duration_1_activate = g_signal_connect(m_duration_1, "activate", G_CALLBACK(_44), this);

  this->m_duration_2_activate = g_signal_connect(m_duration_2, "activate", G_CALLBACK(_46), this);

  this->m_duration_3_activate = g_signal_connect(m_duration_3, "activate", G_CALLBACK(_48), this);

  this->m_duration_4_activate = g_signal_connect(m_duration_4, "activate", G_CALLBACK(_50), this);

  this->m_duration_5_activate = g_signal_connect(m_duration_5, "activate", G_CALLBACK(_52), this);

  this->m_duration_6_activate = g_signal_connect(m_duration_6, "activate", G_CALLBACK(_54), this);

  this->m_duration_7_activate = g_signal_connect(m_duration_7, "activate", G_CALLBACK(_56), this);

  this->m_zoom_0_activate = g_signal_connect(m_zoom_0, "activate", G_CALLBACK(_58), this);

  this->m_zoom_1_activate = g_signal_connect(m_zoom_1, "activate", G_CALLBACK(_60), this);

  this->m_zoom_2_activate = g_signal_connect(m_zoom_2, "activate", G_CALLBACK(_62), this);

  this->m_zoom_3_activate = g_signal_connect(m_zoom_3, "activate", G_CALLBACK(_64), this);

  this->tempo_entry_activate = g_signal_connect(this->tempo_entry, "activate", G_CALLBACK(_66), this);

  this->duration_1_clicked = g_signal_connect(this->duration_1, "clicked", G_CALLBACK(_67), this);

  this->duration_2_clicked = g_signal_connect(this->duration_2, "clicked", G_CALLBACK(_68), this);

  this->duration_4_clicked = g_signal_connect(this->duration_4, "clicked", G_CALLBACK(_69), this);

  this->duration_8_clicked = g_signal_connect(this->duration_8, "clicked", G_CALLBACK(_70), this);

  this->duration_16_clicked = g_signal_connect(this->duration_16, "clicked", G_CALLBACK(_71), this);

  this->duration_32_clicked = g_signal_connect(this->duration_32, "clicked", G_CALLBACK(_72), this);

  this->duration_64_clicked = g_signal_connect(this->duration_64, "clicked", G_CALLBACK(_73), this);

  this->duration_128_clicked = g_signal_connect(this->duration_128, "clicked", G_CALLBACK(_74), this);

  this->zoom1_clicked = g_signal_connect(this->zoom1, "clicked", G_CALLBACK(_76), this);

  this->zoom2_clicked = g_signal_connect(this->zoom2, "clicked", G_CALLBACK(_78), this);

  this->zoom3_clicked = g_signal_connect(this->zoom3, "clicked", G_CALLBACK(_80), this);

  this->zoom4_clicked = g_signal_connect(this->zoom4, "clicked", G_CALLBACK(_82), this);

  this->d_expose = g_signal_connect(this->d, "expose-event", G_CALLBACK(_83), this);
  this->d_key = g_signal_connect(this->d, "key-press-event", G_CALLBACK(_84), this);
  this->d_focus = g_signal_connect(this->d, "focus-in-event", G_CALLBACK(_85), this);
  this->d_focus = g_signal_connect(this->d, "focus-out-event", G_CALLBACK(_85), this);
  this->d_pointer_motion = g_signal_connect(this->d, "motion-notify-event", G_CALLBACK(_86), this);
  this->d_pointer_press = g_signal_connect(this->d, "button-press-event", G_CALLBACK(_86), this);
  this->d_pointer_release = g_signal_connect(this->d, "button-release-event", G_CALLBACK(_86), this);

  {
    PangoFontDescription *font_desc;
    PangoContext *context;
    PangoLayout *layout;
    GTK_WIDGET_FLAGS(this->d) |= GTK_CAN_FOCUS;
    gtk_widget_grab_focus(this->d);

    /* getting fonts for text lines in the document */
#define FONT "sans"
    font_desc = pango_font_description_from_string(FONT " 12");
    context = gtk_widget_create_pango_context(this->d);
    layout = pango_layout_new(context);
    pango_layout_set_font_description(layout, font_desc);
    this->fonts[0] = layout;

    font_desc = pango_font_description_from_string(FONT " 24");
    context = gtk_widget_create_pango_context(this->d);
    layout = pango_layout_new(context);
    pango_layout_set_font_description(layout, font_desc);
    this->fonts[1] = layout;

    font_desc = pango_font_description_from_string(FONT " 36");
    context = gtk_widget_create_pango_context(this->d);
    layout = pango_layout_new(context);
    pango_layout_set_font_description(layout, font_desc);
    this->fonts[2] = layout;

    font_desc = pango_font_description_from_string(FONT " 48");
    context = gtk_widget_create_pango_context(this->d);
    layout = pango_layout_new(context);
    pango_layout_set_font_description(layout, font_desc);
    this->fonts[3] = layout;

    /* registering grey stuff */
    greyreg(GREY_MENU_FILE, m_0);
    greyreg(GREY_MENU_NEW, m_file_0);
    greyreg(GREY_MENU_OPEN, m_file_1);
    greyreg(GREY_MENU_SAVE, m_file_2);
    greyreg(GREY_MENU_SAVE_AS, m_file_3);
    greyreg(GREY_MENU_OPTIONS, m_file_5);
    greyreg(GREY_MENU_QUIT, m_file_7);

    greyreg(GREY_MENU_EDIT, m_1);
    greyreg(GREY_MENU_UNDO, m_edit_0);
    greyreg(GREY_MENU_REDO, m_edit_1);
    greyreg(GREY_MENU_COPY, m_edit_3);
    greyreg(GREY_MENU_PASTE, m_edit_4);
    greyreg(GREY_MENU_ZOOM, m_edit_6);

    greyreg(GREY_MENU_TOOL, m_2);
    greyreg(GREY_MENU_VKEYBOARD, m_tool_0);

    greyreg(GREY_MENU_HELP, m_3);
    greyreg(GREY_MENU_ABOUT, m_help_0);
    greyreg(GREY_MENU_AUTHORS, m_help_2);
    greyreg(GREY_MENU_QUICK_HELP, m_help_4);
    greyreg(GREY_MENU_TUTORIAL, m_help_5);
    greyreg(GREY_MENU_KNOWN_BUGS, m_help_7);
    greyreg(GREY_MENU_TODO, m_help_8);

    /* setup duration selection buttons */
    gtk_button_set_relief(this->duration_1, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_2, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_4, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_8, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_16, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_32, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_64, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->duration_128, GTK_RELIEF_NONE);
    gtk_toggle_button_set_mode(this->duration_1, FALSE);
    gtk_toggle_button_set_mode(this->duration_2, FALSE);
    gtk_toggle_button_set_mode(this->duration_4, FALSE);
    gtk_toggle_button_set_mode(this->duration_8, FALSE);
    gtk_toggle_button_set_mode(this->duration_16, FALSE);
    gtk_toggle_button_set_mode(this->duration_32, FALSE);
    gtk_toggle_button_set_mode(this->duration_64, FALSE);
    gtk_toggle_button_set_mode(this->duration_128, FALSE);

    /* setup zoom buttons */
    gtk_toggle_button_set_mode(this->zoom1, FALSE);
    gtk_toggle_button_set_mode(this->zoom2, FALSE);
    gtk_toggle_button_set_mode(this->zoom3, FALSE);
    gtk_toggle_button_set_mode(this->zoom4, FALSE);
    gtk_button_set_relief(this->zoom1, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->zoom2, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->zoom3, GTK_RELIEF_NONE);
    gtk_button_set_relief(this->zoom4, GTK_RELIEF_NONE);
  }

  return 0;
}

