/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#include "mem.h"

#include <stdlib.h>
#include <string.h>

#include "error.h"

#define RESIZE_CLEAR_INC(data, size, maxsize, type, inc) \
  do { \
    if (size == maxsize) { \
      type *new; \
      int ns = maxsize + inc; \
      if (maxsize) \
        new = realloc(data, ns * sizeof(type)); \
      else \
        new = malloc(ns * sizeof(type)); \
      if (!new) { \
        set_error(OOM); \
        return 0; \
      } \
      data = new; \
      maxsize = ns; \
    } \
    memset(data+size, 0, sizeof(type)); \
    size++; \
  } while (0)

int alloc_line(doc *d)
{
  RESIZE_CLEAR_INC(d->data, d->size, d->maxsize, line, 256);
  return 1;
}

int alloc_chord(doc *d, int line)
{
  RESIZE_CLEAR_INC(d->data[line].u.music.data, d->data[line].u.music.size,
                   d->data[line].u.music.maxsize, chord, 64);
  return 1;
}

int alloc_note(doc *d, int line, int chord)
{
  RESIZE_CLEAR_INC(CHORD_DATA(d, line, chord),
                   CHORD_SIZE(d, line, chord),
                   CHORD_MAXSIZE(d, line, chord), elem, 8);
  return 1;
}

int alloc_select(doc *d)
{
  RESIZE_CLEAR_INC(d->sel_buf.data, d->sel_buf.size, d->sel_buf.maxsize,
                   copy_datum, 128);
  return 1;
}
