/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _OPTIONS_H_
#define _OPTIONS_H_

#include <stdio.h>

typedef enum {
  PLAY_OSS, PLAY_MIDI, PLAY_MIDI_ALSA
} play_type;

typedef struct {
#if 0
  /* maybe one day */
  int depth_of_undo_redo;
#endif
#if 0
  /* maybe one day */
  int oss_buffer_size;
  int oss_nb_buffers;
#endif
  char audio_oss_file[FILENAME_MAX];
  char audio_midi_file[FILENAME_MAX];
  play_type ptype;
  int midi_device;	/* a value of -1 means use audio_midi_file */
  int midi_instrument;
  int midi_adjust;	/* 0 for current stuff, -12 for 1 octave lower */
  int midi_volume;
} options;

void default_options(options *);
void load_options(options *);
void save_options(options *);

#endif /* _OPTIONS_H_ */
