/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

/* an include out of #ifdef stuff
 * a bit ugly but doc.h needs select.h
 * and select. needs the start of doc.h for struct chord
 * hell I should create another .h where to put struct chord
 */
#include "doc.h"

#ifndef _SELECT_H_
#define _SELECT_H_

#include "typedefs.h"

/* the selection starts BEFORE the point (start_line, start_chord) and
 * ends BEFORE the point (end_line, end_chord)
 * if there is no current selection, start_line = -1
 */
typedef struct {
  int start_line;
  int start_chord;
  int end_line;
  int end_chord;
} selection;

enum copy_datum_type { CD_LINE_MARKER, CD_CHORD, CD_TEXT };

typedef struct {
  enum copy_datum_type type;
  union {
    chord chord;
    char *text;
  } u;
} copy_datum;

typedef struct {
  copy_datum *data;
  int size;
  int maxsize;
} copy_buffer;

int copy_selection(struct doc *);
int paste_selection(struct doc *);

void destroy_selection(struct doc *);

int is_after(int, int, int, int);
int in_selection(struct doc *, int, int);

#endif /* _SELECT_H_ */
