/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state save_state(char *ret_name, void *dady, cursor *c) {
  data {
    file_gui gui;
    char *ret_name;
    int i;
    cursor *cursor;
  }

  enter {
    data->ret_name = ret_name;
    data->cursor = c;
    init_file_gui(&data->gui, dady, "Save", _owner);
    gtk_wrapper_widget_show_all(data->gui.f);
    disable_cursor(c);
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->gui.f);
    enable_cursor(data->cursor);
  }

  action file_ok(char *n) {
    if (strlen(n) > FILENAME_MAX - 1) {
      CALL(warning_state,
        "The file's name you gave is too long\n"
        "(you should not read this error message,\n"
        "contact the authors and explain what you\ndid to get this error).",
        data->gui.f);
      BREAK;
    }
    strcpy(data->ret_name, n);
    if (file_exist(n)) {
      data->i = 0;
      CALL(save_confirm_state, data->gui.f, &data->i);
      if (data->i == 0) BREAK;
    }
    RETURN;
  }

  action file_cancel {
    data->ret_name[0] = 0;
    RETURN;
  }
}

state save_as_state(char *ret_name, void *dady, cursor *c) {
  data {
    file_gui gui;
    char *ret_name;
    int i;
    cursor *cursor;
  }

  enter {
    data->ret_name = ret_name;
    data->cursor = c;
    init_file_gui(&data->gui, dady, "Save as", _owner);
    gtk_wrapper_widget_show_all(data->gui.f);
    disable_cursor(c);
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->gui.f);
    enable_cursor(data->cursor);
  }

  action file_ok(char *n) {
    if (strlen(n) > FILENAME_MAX - 1) {
      CALL(warning_state,
        "The file's name you gave is too long\n"
        "(you should not read this error message,\n"
        "contact the authors and explain what you\ndid to get this error).",
        data->gui.f);
      BREAK;
    }
    strcpy(data->ret_name, n);
    if (file_exist(n)) {
      data->i = 0;
      CALL(save_confirm_state, data->gui.f, &data->i);
      if (data->i == 0) BREAK;
    }
    RETURN;
  }

  action file_cancel {
    data->ret_name[0] = 0;
    RETURN;
  }
}

state save_confirm_state(void *dady, int *ret)
{
  data {
    yes_no_gui g;
    int *i;
  }

  enter {
    data->i = ret;
    init_yes_no_gui(&data->g, dady,
        "The file already exist.\nDo you want to overwrite it?",
        _owner);
    gtk_wrapper_widget_show_all(data->g.win);
    greyall();
  }

  leave {
    gtk_wrapper_widget_destroy(data->g.win);
    ungreyall();
  }

  action yes_no_yes {
    *data->i = 1;
    RETURN;
  }

  action yes_no_no {
    *data->i = 0;
    RETURN;
  }
}

state load_state(char *ret_name, void *dady, cursor *c) {
  data {
    file_gui gui;
    char *ret_name;
    cursor *cursor;
  }

  enter {
    data->ret_name = ret_name;
    data->cursor = c;
    init_file_gui(&data->gui, dady, "Load", _owner);
    gtk_wrapper_widget_show_all(data->gui.f);
    disable_cursor(c);
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->gui.f);
    enable_cursor(data->cursor);
  }

  action file_ok(char *n) {
    if (strlen(n) > FILENAME_MAX - 1) {
      CALL(warning_state,
        "The file's name you gave is too long\n"
        "(you should not read this error message,\n"
        "contact the authors and explain what you\ndid to get this error).",
        data->gui.f);
      BREAK;
    }
    strcpy(data->ret_name, n);
    if (!file_exist(n)) {
      CALL(warning_state, "The file does not exist.", data->gui.f);
      BREAK;
    }
    RETURN;
  }

  action file_cancel {
    data->ret_name[0] = 0;
    RETURN;
  }
}
