/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

/* a little tool to replace '%%import "FILE"' from stdin by the
 * content of FILE in the stdout, not changing the rest.
 * You cannot use %% in your file, the tool requires it is
 * followed by 'import "FILE"'.
 * return 1 to the shell if error, 0 if ok
 */

#include <stdio.h>
#include <ctype.h>

int do_include(char *name)
{
  FILE *f = fopen(name, "r");
  int c;
  if (!f) return 0;
  printf("/* included from %s */\n", name);
  while (1) {
    c = getc(f);
    if (c == EOF) break;
    if (putchar(c) == -1) return 0;
  }
  fclose(f);
  printf("/* end of inclusion from %s */\n", name);
  return 1;
}

int do_import(void)
{
  char buf[FILENAME_MAX];
  int i;
  int c;
  c = getchar(); if (c != 'i') return 0;
  c = getchar(); if (c != 'm') return 0;
  c = getchar(); if (c != 'p') return 0;
  c = getchar(); if (c != 'o') return 0;
  c = getchar(); if (c != 'r') return 0;
  c = getchar(); if (c != 't') return 0;
  do c = getchar(); while (isspace(c));
  if (c != '"') return 0;
  i = 0;
  while (1) {
    c = getchar();
    if (c == EOF) return 0;
    if (c == '"') break;
    if (i == FILENAME_MAX-1) return 0;
    buf[i] = c;
    i++;
  }
  if (i == 0) return 0;
  buf[i] = 0;
  return do_include(buf);
}

int main(void)
{
  int c;
  printf("/* generated by 'import', you should not modify this file.\n");
  printf(" * modify the .i instead.\n");
  printf(" */\n\n");
  while (1) {
    c = getchar();
    if (c == EOF) break;
    if (c == '%') {
      c = getchar();
      if (c == EOF) {
        if (putchar('%') == -1) return 1;
        break;
      }
      if (c != '%') {
        if (putchar('%') == -1) return 1;
        if (putchar(c) == -1) return 1;
        continue;
      }
      if (!do_import()) return 1;
      continue;
    }
    if (putchar(c) == -1) return 1;
  }
  fflush(stdout);
  return 0;
}
