/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state play_state(doc *d)
{
  data {
    doc *d;
  }

  enter {
    data->d = d;
    disable_cursor(&d->cursor);
    set_info(data->d, "Playback's mode on");
    greyall();
  }

  leave {
    ungreyall();
    stop_play(data->d);
    enable_cursor(&data->d->cursor);
    set_info(data->d, "");
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;

    switch (key) {
      default: break;
      case 'p':
      case ' ': goto return_key_and_set_cursor;
      case GDK_Escape: goto return_key;
    }
    BREAK;

return_key:
    RETURN;

return_key_and_set_cursor: {
      int line = -1;
      int chord;
      if (data->d->options.ptype == PLAY_OSS) {
        if (data->d->p.current_chord != -1) {
           line = data->d->p.starting_chord[data->d->p.current_chord].line;
           chord = data->d->p.starting_chord[data->d->p.current_chord].chord;
        }
      } else {
         if (data->d->p.current_chord != -1) {
           line = data->d->p.processed_line;
           chord = data->d->p.processed_chord;
         }
      }
      if (line != -1) {
        data->d->cursor.line = line;
        data->d->cursor.chord = chord;
      } else {
        /* no line/chord? we're at the end */
        data->d->cursor.line = data->d->size - 1;
        switch (data->d->data[data->d->size - 1].type) {
          case LINE_TEXT: data->d->cursor.chord = 1; break;
          case LINE_MUSIC:
            data->d->cursor.chord =
                LINE_MUSIC_SIZE(data->d, data->d->size - 1);
            break;
        }
      }
      RETURN;
    }
  }
}
