/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_delete(tutorial_gui *g, struct gui *master_gui,
                      int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/* 19 steps */
/* chord note note chord chord
0 right
1 del
2 right
3 right
4 del
5 left
6 left
7 left
8 i
9 up
10 up
11 up
12 del
13 esc
14 right
15 right
16 backspace
17 right
18 backspace
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_delete.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    data->d->maxsize = 1;
    /* put 5 note on the line */
    tut_lines[0].u.music.size = 5;
    tut_lines[0].u.music.maxsize = 5;
    /* create a note G */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 4;
    tut_chords[0].u.chord.maxsize = 4;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+4;
    tut_chords[1].u.chord.size = 1;
    tut_chords[1].u.chord.maxsize = 1;
    tut_chords[2].type = NOTES_CHORD;
    tut_chords[2].u.chord.data = tut_elems+5;
    tut_chords[2].u.chord.size = 1;
    tut_chords[2].u.chord.maxsize = 1;
    tut_chords[3].type = NOTES_CHORD;
    tut_chords[3].u.chord.data = tut_elems+6;
    tut_chords[3].u.chord.size = 3;
    tut_chords[3].u.chord.maxsize = 3;
    tut_chords[4].type = NOTES_CHORD;
    tut_chords[4].u.chord.data = tut_elems+9;
    tut_chords[4].u.chord.size = 3;
    tut_chords[4].u.chord.maxsize = 3;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = -8;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = -4;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 0;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    tut_elems[3].type = NOTE;
    tut_elems[3].u.note.pitch = 3;
    tut_elems[3].u.note.alteration = DIESE;
    tut_elems[3].u.note.duration = CROCHE;
    tut_elems[3].u.note.nb_dots = 1;
    tut_elems[4].type = NOTE;
    tut_elems[4].u.note.pitch = 2;
    tut_elems[4].u.note.alteration = BEMOL;
    tut_elems[4].u.note.duration = DCROCHE;
    tut_elems[4].u.note.nb_dots = 0;
    tut_elems[5].type = NOTE;
    tut_elems[5].u.note.pitch = 4;
    tut_elems[5].u.note.alteration = NORMAL;
    tut_elems[5].u.note.duration = DCROCHE;
    tut_elems[5].u.note.nb_dots = 1;
    tut_elems[6].type = NOTE;
    tut_elems[6].u.note.pitch = 4;
    tut_elems[6].u.note.alteration = DIESE;
    tut_elems[6].u.note.duration = BLANCHE;
    tut_elems[6].u.note.nb_dots = 0;
    tut_elems[7].type = NOTE;
    tut_elems[7].u.note.pitch = 7;
    tut_elems[7].u.note.alteration = NORMAL;
    tut_elems[7].u.note.duration = BLANCHE;
    tut_elems[7].u.note.nb_dots = 0;
    tut_elems[8].type = NOTE;
    tut_elems[8].u.note.pitch = 12;
    tut_elems[8].u.note.alteration = NORMAL;
    tut_elems[8].u.note.duration = BLANCHE;
    tut_elems[8].u.note.nb_dots = 0;
    tut_elems[9].type = NOTE;
    tut_elems[9].u.note.pitch = -6;
    tut_elems[9].u.note.alteration = NORMAL;
    tut_elems[9].u.note.duration = NOIRE;
    tut_elems[9].u.note.nb_dots = 0;
    tut_elems[10].type = NOTE;
    tut_elems[10].u.note.pitch = -3;
    tut_elems[10].u.note.alteration = NORMAL;
    tut_elems[10].u.note.duration = NOIRE;
    tut_elems[10].u.note.nb_dots = 0;
    tut_elems[11].type = NOTE;
    tut_elems[11].u.note.pitch = 0;
    tut_elems[11].u.note.alteration = NORMAL;
    tut_elems[11].u.note.duration = NOIRE;
    tut_elems[11].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the right key");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case GDK_Right:
        if (data->step == 0 || data->step == 2 || data->step == 3 ||
            data->step == 14 || data->step == 15 || data->step == 17) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 1: SET_ACTION("Press the key 'del' to delete the note");
              break;
            case 3:
            case 15:
              SET_ACTION("Press the right key again");
              break;
            case 4: SET_ACTION("Press the key 'del' to delete the chord");
              break;
            case 16:
              SET_ACTION("Press the key 'backspace' to delete the note");
              break;
            case 18:
              SET_ACTION("Press the key 'backspace' to delete the chord");
              break;
          }
        }
        break;
      case GDK_Delete:
        if (data->step == 1) {
          data->step++;
          tut_lines[0].u.music.size--;
          tut_chords[1].u.chord.data = tut_elems+5;
          tut_chords[1].u.chord.size = 1;
          tut_chords[2].u.chord.data = tut_elems+6;
          tut_chords[2].u.chord.size = 3;
          tut_chords[3].u.chord.data = tut_elems+9;
          tut_chords[3].u.chord.size =  3;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        } else if (data->step == 4) {
          data->step++;
          tut_lines[0].u.music.size--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the left key");
        } else if (data->step == 12) {
          data->step++;
          tut_chords[0].u.chord.size--;
          data->d->cursor.note--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'Escape'");
        }
        break;
      case GDK_Left:
        if (data->step >= 5 && data->step <= 7) {
          data->step++;
          data->d->cursor.chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 6)
            SET_ACTION("Press the left key again");
          else if (data->step == 7)
            SET_ACTION("Press the left key one more time");
          else
            SET_ACTION("Press the key 'i' (to enter i mode)");
        }
        break;
      case 'i':
        if (data->step == 8) {
          data->step++;
          data->d->cursor.type = SMALL_CURSOR;
          data->d->cursor.note = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        }
        break;
      case GDK_Up:
        if (data->step >= 9 && data->step <= 11) {
          data->step++;
          data->d->cursor.note++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 10)
            SET_ACTION("Press the up key again");
          else if (data->step == 11)
            SET_ACTION("Press the up key one more time");
          else
            SET_ACTION("Press the key 'del' (to delete a note of the chord)");
        }
        break;
      case GDK_Escape:
        if (data->step == 13) {
          data->step++;
          data->d->cursor.type = BIG_CURSOR;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        }
        break;
      case GDK_BackSpace:
        if (data->step == 16) {
          data->step++;
          tut_lines[0].u.music.size--;
          tut_chords[1].u.chord.data = tut_elems+6;
          tut_chords[1].u.chord.size = 3;
          data->d->cursor.chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        } else if (data->step == 18) {
          data->step++;
          tut_lines[0].u.music.size--;
          data->d->cursor.chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
