/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_fine_positioning(tutorial_gui *g, struct gui *master_gui,
                                int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step; /* 12 steps */
/*
steps:
0 i
1 up
2 L
3 m
4 m
5 up
6 O
7 down
8 down
9 m
10 m
11 O
 */
  }

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_fine_positioning.h"
    SET_TEXT_END;
    /* set the lines */
    data->d->size = 1;
    /* put one xhord on the first line */
    tut_lines[0].u.music.size = 1;
    /* create two notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 3;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = DIESE;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 1;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 2;
    tut_elems[1].u.note.alteration = DIESE;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 1;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 3;
    tut_elems[2].u.note.alteration = DIESE;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 1;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press 'i' (to enter i-mode)");
  }

  leave {
    tut_elems[1].u.note.alteration_delta = 0;
    tut_elems[0].u.note.alteration_delta = 0;
    tut_elems[2].u.note.dots_delta = 0;
    tut_elems[0].u.note.dots_delta = 0;
    tut_elems[1].u.note.head_delta = 0;
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 'i':
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.type = SMALL_CURSOR;
          data->d->cursor.note = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        }
        break;
      case GDK_Up:
        if (data->step == 1 || data->step == 5) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.note++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 2)
            SET_ACTION("Press 'L' (to move the note head to the right)");
          else
            SET_ACTION("Press 'O' (to move the dot to the right)");
        }
        break;
      case 'L':
        if (data->step == 2) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[1].u.note.head_delta = images[I_BLACK_HEAD].width-1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press 'm' (to move the # to the left)");
        }
        break;
      case 'm':
        if (data->step == 3 || data->step == 4 ||
            data->step == 9 || data->step == 10) {
          data->step++;
          clear_cursor(&data->d->cursor);
          if (data->step == 4 || data->step == 5)
            tut_elems[1].u.note.alteration_delta -=
                images[I_BLACK_HEAD].width-1;
          else
            tut_elems[0].u.note.alteration_delta -=
                images[I_BLACK_HEAD].width-1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 4:
              SET_ACTION("Press 'm' again");
              break;
            case 5:
              SET_ACTION("Press the up key");
              break;
            case 10:
              SET_ACTION("Press 'm' again");
              break;
            case 11:
              SET_ACTION("Press 'O' (to move the dot to the right)");
              break;
          }
        }
        break;
      case 'O':
        if (data->step == 6 || data->step == 11) {
          data->step++;
          clear_cursor(&data->d->cursor);
          if (data->step == 7)
            tut_elems[2].u.note.dots_delta = images[I_BLACK_HEAD].width-1;
          else
            tut_elems[0].u.note.dots_delta = images[I_BLACK_HEAD].width-1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 7)
            SET_ACTION("Press the down key");
          else
              SET_ACTION(
  "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
      case GDK_Down:
        if (data->step == 7 || data->step == 8) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.note--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 8)
            SET_ACTION("Press the down key again");
          else
            SET_ACTION("Press 'm' (to move the # to the left)");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
