/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_mesure_bars(tutorial_gui *g, struct gui *master_gui,
                           int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/* g a b c d e f g a b
0 right
1 right
2 right
3 |
4 right
5 right
6 right
7 right
8 right
9 |
10 left
11 left
12 left
13 left
14 backspace
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_mesure_bars.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    tut_lines[0].u.music.size = 10;
    /* create 10 notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+1;
    tut_chords[1].u.chord.size = 1;
    tut_chords[2].type = NOTES_CHORD;
    tut_chords[2].u.chord.data = tut_elems+2;
    tut_chords[2].u.chord.size = 1;
    tut_chords[3].type = NOTES_CHORD;
    tut_chords[3].u.chord.data = tut_elems+3;
    tut_chords[3].u.chord.size = 1;
    tut_chords[4].type = NOTES_CHORD;
    tut_chords[4].u.chord.data = tut_elems+4;
    tut_chords[4].u.chord.size = 1;
    tut_chords[5].type = NOTES_CHORD;
    tut_chords[5].u.chord.data = tut_elems+5;
    tut_chords[5].u.chord.size = 1;
    tut_chords[6].type = NOTES_CHORD;
    tut_chords[6].u.chord.data = tut_elems+6;
    tut_chords[6].u.chord.size = 1;
    tut_chords[7].type = NOTES_CHORD;
    tut_chords[7].u.chord.data = tut_elems+7;
    tut_chords[7].u.chord.size = 1;
    tut_chords[8].type = NOTES_CHORD;
    tut_chords[8].u.chord.data = tut_elems+8;
    tut_chords[8].u.chord.size = 1;
    tut_chords[9].type = NOTES_CHORD;
    tut_chords[9].u.chord.data = tut_elems+9;
    tut_chords[9].u.chord.size = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 0;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 1;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 2;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    tut_elems[3].type = NOTE;
    tut_elems[3].u.note.pitch = 3;
    tut_elems[3].u.note.alteration = NORMAL;
    tut_elems[3].u.note.duration = NOIRE;
    tut_elems[3].u.note.nb_dots = 0;
    tut_elems[4].type = NOTE;
    tut_elems[4].u.note.pitch = 4;
    tut_elems[4].u.note.alteration = NORMAL;
    tut_elems[4].u.note.duration = NOIRE;
    tut_elems[4].u.note.nb_dots = 0;
    tut_elems[5].type = NOTE;
    tut_elems[5].u.note.pitch = 5;
    tut_elems[5].u.note.alteration = NORMAL;
    tut_elems[5].u.note.duration = NOIRE;
    tut_elems[5].u.note.nb_dots = 0;
    tut_elems[6].type = NOTE;
    tut_elems[6].u.note.pitch = 6;
    tut_elems[6].u.note.alteration = NORMAL;
    tut_elems[6].u.note.duration = NOIRE;
    tut_elems[6].u.note.nb_dots = 0;
    tut_elems[7].type = NOTE;
    tut_elems[7].u.note.pitch = 7;
    tut_elems[7].u.note.alteration = NORMAL;
    tut_elems[7].u.note.duration = NOIRE;
    tut_elems[7].u.note.nb_dots = 0;
    tut_elems[8].type = NOTE;
    tut_elems[8].u.note.pitch = 8;
    tut_elems[8].u.note.alteration = NORMAL;
    tut_elems[8].u.note.duration = NOIRE;
    tut_elems[8].u.note.nb_dots = 0;
    tut_elems[9].type = NOTE;
    tut_elems[9].u.note.pitch = 9;
    tut_elems[9].u.note.alteration = NORMAL;
    tut_elems[9].u.note.duration = NOIRE;
    tut_elems[9].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the right key");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case GDK_Right:
        if ((data->step >= 0 && data->step <= 2) ||
            (data->step >= 4 && data->step <= 8)) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 1:
            case 5: SET_ACTION("Press the right key again"); break;
            case 2:
            case 6: SET_ACTION("Press the right key one more time"); break;
            case 3:
            case 9: SET_ACTION("Press the key '|'"); break;
            case 7: SET_ACTION("Press the right key once again"); break;
            case 8: SET_ACTION("Press the right key a last time"); break;
          }
        }
        break;
      case '|':
        if (data->step == 3) {
          data->step++;
          tut_lines[0].u.music.size++;
          tut_chords[10] = tut_chords[9];
          tut_chords[9] = tut_chords[8];
          tut_chords[8] = tut_chords[7];
          tut_chords[7] = tut_chords[6];
          tut_chords[6] = tut_chords[5];
          tut_chords[5] = tut_chords[4];
          tut_chords[4] = tut_chords[3];
          tut_chords[3].type = MESURE_BREAK;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        } else if (data->step == 9) {
          data->step++;
          tut_lines[0].u.music.size++;
          tut_chords[11] = tut_chords[10];
          tut_chords[10] = tut_chords[9];
          tut_chords[9] = tut_chords[8];
          tut_chords[8].type = MESURE_BREAK;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the left key");
        }
        break;
      case GDK_Left:
        if (data->step >= 10 && data->step <= 13) {
          data->step++;
          data->d->cursor.chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 11: SET_ACTION("Press the left key again"); break;
            case 12: SET_ACTION("Press the left key one more time"); break;
            case 13: SET_ACTION("Press the left key a last time"); break;
            case 14: SET_ACTION(
     "Press the key 'backspace' to delete the bar line"); break;
          }
        }
        break;
      case GDK_BackSpace:
        if (data->step == 14) {
          data->step++;
          data->d->cursor.chord--;
          tut_lines[0].u.music.size--;
          tut_chords[3] = tut_chords[4];
          tut_chords[4] = tut_chords[5];
          tut_chords[5] = tut_chords[6];
          tut_chords[6] = tut_chords[7];
          tut_chords[7] = tut_chords[8];
          tut_chords[8] = tut_chords[9];
          tut_chords[9] = tut_chords[10];
          tut_chords[10] = tut_chords[11];
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
