/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_modif_note_alteration(tutorial_gui *g, struct gui *master_gui,
                                     int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step; /* 15 steps */
/*
steps:
0 down
1 # (note 2)
2 right
3 # (note 3)
4 # (note 3)
5 up
6 right
7 # (note 1)
8 # (note 1)
9 # (note 1)
10 left
11 # (note 0)
12 # (note 0)
13 # (note 0)
14 # (note 0)
 */
  }

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_modif_note_alteration.h"
    SET_TEXT_END;
    /* set the lines */
    data->d->size = 2;
    data->d->maxsize = 2;
    /* put two notes on the first line */
    tut_lines[0].u.music.size = 2;
    tut_lines[0].u.music.maxsize = 2;
    /* create two notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[0].u.chord.maxsize = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems + 1;
    tut_chords[1].u.chord.size = 1;
    tut_chords[1].u.chord.maxsize = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = -5;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = -6;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    /* second line */
    tut_lines[1].u.music.size = 3;
    tut_lines[1].u.music.maxsize = 3;
    tut_lines[1].u.music.data = tut_chords + 2;
    /* create three notes */
    tut_chords[2].type = NOTES_CHORD;
    tut_chords[2].u.chord.data = tut_elems + 2;
    tut_chords[2].u.chord.size = 1;
    tut_chords[2].u.chord.maxsize = 1;
    tut_chords[3].type = NOTES_CHORD;
    tut_chords[3].u.chord.data = tut_elems + 3;
    tut_chords[3].u.chord.size = 1;
    tut_chords[3].u.chord.maxsize = 1;
    tut_chords[4].type = NOTES_CHORD;
    tut_chords[4].u.chord.data = tut_elems + 4;
    tut_chords[4].u.chord.size = 1;
    tut_chords[4].u.chord.maxsize = 1;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = -7;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    tut_elems[3].type = NOTE;
    tut_elems[3].u.note.pitch = -8;
    tut_elems[3].u.note.alteration = NORMAL;
    tut_elems[3].u.note.duration = NOIRE;
    tut_elems[3].u.note.nb_dots = 0;
    tut_elems[4].type = NOTE;
    tut_elems[4].u.note.pitch = -9;
    tut_elems[4].u.note.alteration = NORMAL;
    tut_elems[4].u.note.duration = NOIRE;
    tut_elems[4].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the down arrow");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case GDK_Down:
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.line++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#'");
        }
        break;
      case GDK_Right:
        if (data->step == 2 || data->step == 6) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#'");
        }
        break;
      case GDK_Left:
        if (data->step == 10) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#'");
        }
        break;
      case GDK_Up:
        if (data->step == 5) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.chord = 0;
          data->d->cursor.line--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        }
        break;
      case '#':
        if (data->step == 1) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[2].u.note.alteration = DIESE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        } else
        if (data->step == 3) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[3].u.note.alteration = DIESE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' again");
        } else
        if (data->step == 4) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[3].u.note.alteration = BEMOL;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        } else
        if (data->step == 7) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[1].u.note.alteration = DIESE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' again");
        } else
        if (data->step == 8) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[1].u.note.alteration = BEMOL;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' one more time");
        } else
        if (data->step == 9) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[1].u.note.alteration = BECARRE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the left key");
        } else
        if (data->step == 11) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.alteration = DIESE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' again");
        } else
        if (data->step == 12) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.alteration = BEMOL;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' one more time");
        } else
        if (data->step == 13) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.alteration = BECARRE;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '#' a last time");
        } else
        if (data->step == 14) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.alteration = NORMAL;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
              SET_ACTION(
  "Well done! Press the button 'next' to continue the tutorial.");
        } else
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
