/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_modif_note_duration(tutorial_gui *g, struct gui *master_gui,
                                   int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step; /* 6 steps */
  }

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_modif_note_duration.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    data->d->maxsize = 1;
    /* put two note on the line */
    tut_lines[0].u.music.size = 2;
    tut_lines[0].u.music.maxsize = 2;
    /* create a note B */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[0].u.chord.maxsize = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems + 1;
    tut_chords[1].u.chord.size = 1;
    tut_chords[1].u.chord.maxsize = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = -2;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 6;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the right arrow");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case GDK_Right:
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 't'");
        }
        break;
      case 't':
        if (data->step >= 1 && data->step < 3) {
          data->step++;
          tut_elems[1].u.note.duration++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 2:
              SET_ACTION("Press the key 't' again");
              break;
            case 3:
              SET_ACTION("Press the key 'T' (shift+t or caps-lock)");
              break;
          }
        }
        break;
      case 'T':
        if (data->step >= 3 && data->step < 6) {
          data->step++;
          tut_elems[1].u.note.duration--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 4:
              SET_ACTION("Press the key 'T' again");
              break;
            case 5:
              SET_ACTION("Press the key 'T' one more time");
              break;
            case 6:
              SET_ACTION(
  "Well done! Press the button 'next' to continue the tutorial.");
              break;
          }
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
