/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_selection(tutorial_gui *g, struct gui *master_gui, int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/* a b | c / free line
0 right
1 right
2 right
3 shift+right
4 tab
5 shift+left
6 shift+left
7 ctrl+c
8 escape
9 down
10 ctrl+v
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_selection.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 2;
    tut_lines[0].u.music.size = 4;
    tut_lines[1].u.music.size = 0;
    tut_lines[1].u.music.data = tut_chords+4;
    /* create three notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+1;
    tut_chords[1].u.chord.size = 1;
    tut_chords[2].type = MESURE_BREAK;
    tut_chords[3].type = NOTES_CHORD;
    tut_chords[3].u.chord.data = tut_elems+2;
    tut_chords[3].u.chord.size = 1;
    tut_chords[4].type = NOTES_CHORD;
    tut_chords[4].u.chord.data = tut_elems+1;
    tut_chords[4].u.chord.size = 1;
    tut_chords[5].type = MESURE_BREAK;
    tut_chords[6].type = NOTES_CHORD;
    tut_chords[6].u.chord.data = tut_elems+2;
    tut_chords[6].u.chord.size = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 2;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 3;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the right key");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) {
      if (key == 'c' && data->step == 7) {
        data->step++;
        size_reset(data->d);
        size_post_treatment(data->d);
        reset_cursor(&data->d->cursor);
        SET_ACTION("Press the key 'escape'");
      }
      if (key == 'v' && data->step == 10) {
        data->step++;
        tut_lines[1].u.music.size = 3;
        size_reset(data->d);
        size_post_treatment(data->d);
        reset_cursor(&data->d->cursor);
        SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
      }
      BREAK;
    }
    switch (key) {
      case GDK_Right:
        if (!shift && data->step >= 0 && data->step <= 2) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 1: SET_ACTION("Press the right key again"); break;
            case 2: SET_ACTION("Press the right key one more time"); break;
            case 3: SET_ACTION(
                      "Press the shift+right key to start the selection");
              break;
          }
        } else if (shift && data->step == 3) {
          data->step++;
          data->d->cursor.chord++;
          data->d->sel.start_line = 0;
          data->d->sel.start_chord = 3;
          data->d->sel.end_line = 0;
          data->d->sel.end_chord = 4;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'TAB' to change the selection's point");
        }
        break;
      case GDK_Tab:
        if (data->step == 4) {
          data->step++;
          data->d->cursor.chord = 3;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the shift+left key to continue the selection");
        }
        break;
      case GDK_Left:
        if (shift && data->step >= 5 && data->step <= 6) {
          data->step++;
          data->d->cursor.chord--;
          data->d->sel.start_chord--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 6: SET_ACTION("Press the shift+left key again"); break;
            case 7: SET_ACTION(
                "Press the key 'ctrl+c' to copy the selection"); break;
          }
        }
        break;
      case GDK_Escape:
        if (data->step == 8) {
          data->step++;
          data->d->sel.start_line = -1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the down key");
        }
        break;
      case GDK_Down:
        if (data->step == 9) {
          data->step++;
          data->d->cursor.chord = 0;
          data->d->cursor.line++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'ctrl+v' to paste the selection");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
