/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_silences(tutorial_gui *g, struct gui *master_gui, int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/* steps
0 s
1 u
2 u
3 u
4 U
5 t
6 t
7 T
8 T
9 T
10 .
11 .
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_silences.h"
    SET_TEXT_END;
    /* set the line */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 0;
    tut_elems[0].type = SILENCE;
    tut_elems[0].u.silence.position = 0;
    tut_elems[0].u.silence.duration = NOIRE;
    tut_elems[0].u.silence.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the key 's' to insert a rest (s is for silence)");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 's':
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_lines[0].u.music.size = 1;
          tut_chords[0].u.chord.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
              "Press the key 'u' (to change the position of the rest)");
        }
        break;
      case 'u':
        if (data->step == 1 || data->step == 2 || data->step == 3) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.position++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 2: SET_ACTION("Press the key 'u' again"); break;
            case 3: SET_ACTION("Press the key 'u' one more time"); break;
            case 4: SET_ACTION(
                  "Press the key 'U' (to lower the postion of the rest)");
              break;
          }
        }
        break;
      case 'U':
        if (data->step == 4) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.position--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
              "Press the key 't' (to change the duration of the rest)");
        }
        break;
      case 't':
        if (data->step == 5 || data->step == 6) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.duration++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 6: SET_ACTION("Press the key 't' again"); break;
            case 7: SET_ACTION(
              "Press the key 'T' (to increase the duration of the rest)");
              break;
          }
        }
        break;
      case 'T':
        if (data->step == 7 || data->step == 8 || data->step == 9) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.duration--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 8: SET_ACTION("Press the key 'T' again"); break;
            case 9: SET_ACTION("Press the key 'T' one more time"); break;
            case 10: SET_ACTION(
          "Press the key '.' (to change the number of dots of the rest)");
              break;
          }
        }
        break;
      case '.':
        if (data->step == 10 || data->step == 11) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.nb_dots++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 11: SET_ACTION("Press the key '.' again"); break;
            case 12: SET_ACTION(
          "Well done! Press the button 'next' to continue the tutorial.");
              break;
          }
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
