/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_text(tutorial_gui *g, struct gui *master_gui, int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/*
0 right
1 right
2 shift+enter
3 up
4 shift+enter
5 down
6 del
7 up
8 right
9 backspace
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_text.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    tut_lines[0].u.music.size = 2;
    /* create two notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+1;
    tut_chords[1].u.chord.size = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 2;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    /* reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the right key");
  }

  leave {
    tut_lines[0].type = LINE_MUSIC;
    tut_lines[2].type = LINE_MUSIC;
  }

  action key_press(int key, int control, int shift) {
    switch (key) {
      case GDK_Right:
        if (data->step == 0 || data->step == 1 || data->step == 8) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 1: SET_ACTION("Press the right key again"); break;
            case 2: SET_ACTION(
                      "Press the key 'shift+enter' to create a text line");
              break;
            case 9: SET_ACTION(
                      "Press the key 'backspace' to delete the text line");
              break;
          }
        }
        break;
      case GDK_Return:
        if (shift && data->step == 2) {
          data->step++;
          data->d->size++;
          tut_lines[1].type = LINE_TEXT;
          tut_lines[1].u.text.data = "Text line";
          data->d->cursor.line++;
          data->d->cursor.chord = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        } else if (shift && data->step == 4) {
          data->step++;
          data->d->size++;
          tut_lines[2] = tut_lines[1];
          tut_lines[1] = tut_lines[0];
          tut_lines[0].type = LINE_TEXT;
          tut_lines[0].u.text.data = "Text line";
          data->d->cursor.line++;
          data->d->cursor.chord = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the down key");
        }
        break;
      case GDK_Up:
        if (data->step == 3 || data->step == 7) {
          data->step++;
          data->d->cursor.line--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 4: SET_ACTION(
              "Press the key 'shift+enter' to create a new text line");
              break;
            case 8: SET_ACTION("Press the right key"); break;
          }
        }
        break;
      case GDK_Down:
        if (data->step == 5) {
          data->step++;
          data->d->cursor.line++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'del' to delete the text line");
        }
        break;
      case GDK_Delete:
        if (data->step == 6) {
          data->step++;
          data->d->size--;
          data->d->cursor.line--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        }
        break;
      case GDK_BackSpace:
        if (data->step == 9) {
          data->step++;
          data->d->size--;
          tut_lines[0] = tut_lines[1];
          data->d->cursor.chord = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
