/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_tonality(tutorial_gui *g, struct gui *master_gui,
                        int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/*
0 *
1 u
2 u
3 u
4 u
5 u
6 u
7 right
8 enter
9 *
10 #
11 u
12 u
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_tonality.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    tut_lines[0].u.music.size = 0;
    /* setup chords */
    tut_chords[0].type = TONALITE;
    tut_chords[0].u.tonalite.position = 0;
    tut_chords[0].u.tonalite.alteration = DIESE;
    tut_chords[1].type = TONALITE;
    tut_chords[1].u.tonalite.position = 0;
    tut_chords[1].u.tonalite.alteration = DIESE;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the key '*' (to insert a key signature's element)");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case '*':
        if (data->step == 0) {
          data->step++;
          tut_lines[0].u.music.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
  "Press the key 'u' to change the position of the key signature's element");
        } else if (data->step == 9) {
          data->step++;
          tut_lines[1].u.music.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
      "Press the key '#' to change the type of the key signature's element");
        }
        break;
      case 'u':
        if (data->step >= 1 && data->step <= 6) {
          data->step++;
          tut_chords[0].u.tonalite.position++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 2: SET_ACTION("Press the key 'u' again"); break;
            case 3: SET_ACTION("Press the key 'u' one more time"); break;
            case 4: SET_ACTION("Press the key 'u' another time"); break;
            case 5: SET_ACTION("Press the key 'u' again (we get close!)");
              break;
            case 6: SET_ACTION("Press the key 'u' a last time! (woo!)");
              break;
            case 7: SET_ACTION("Press the right key"); break;
          }
        } else if (data->step >= 11 && data->step <= 12) {
          data->step++;
          tut_chords[1].u.tonalite.position++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 12: SET_ACTION("Press the key 'u' again"); break;
            case 13: SET_ACTION(
          "Well done! Press the button 'next' to continue the tutorial.");
              break;
          }
        }
        break;
      case GDK_Right:
        if (data->step == 7) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'enter' to create a new line");
        }
        break;
      case GDK_Return:
        if (data->step == 8) {
          data->step++;
          data->d->cursor.line++;
          data->d->cursor.chord = 0;
          data->d->size++;
          tut_lines[1].u.music.size = 0;
          tut_lines[1].u.music.data = tut_chords+1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key '*' to insert a key signature's element");
        }
        break;
      case '#':
        if (data->step == 10) {
          data->step++;
          tut_chords[1].u.tonalite.alteration++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
  "Press the key 'u' to change the position of the key signature's element");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
